{{Buttons:    see: CMap Buttons_State_Diagram 
2014/11/18 quick-start pcb-switches: ToucButt running parallel, writes result to TouchButtonRegister, read from there.
2012/06/02 0.1 first release: Button status negative or positiv, about 120 counts per sec, limit:: +-500
2012/06/02: not for production
Modul to manage input buttons: creates state, click and double click signals
And controls an incremental encoder rotational knob input
}}

CON 'Commands for Button and Encoder input
  #1, Idle, Run   ' Load Parameters, .... to be updated, now just simple
  ButtVers = -4   ' Process version at return has to be =< 0 as the number of parameters passed at call is positive!
{
  ButtPola = 1    ' 0: low active button, 1: high active button
  ButtMode = 1    ' 0: read pin directly, 1: Read Pins from Register, 2: Matrix?

  NmbButtPar = 07 ' Button process: number of parameters
DAT  PrCBButt long @ButtCmd, @ButtCoun, @ButtPins, @ButtStat, @ButtClck, @ButtDClk, ToBuRegi                                                      

ButtCmd     long  0 ' to control the Button process
ButtCoun    long  MaxButt ' Counter of the quadrature input, at start: the number of buttons to check
ToBuRegi    long  0       ' 
ButtPins    long  Butt00Pin, Butt01Pin, Butt02Pin, Butt03Pin, Butt04Pin, Butt05Pin, Butt06Pin, Butt07Pin, Butt08Pin, Butt09Pin, Butt10Pin
ButtStat    long  PinA<<5+PinB, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0   ' Status of the button
ButtClck    long  0, 0, 0,  0, 0, 0, 0,  0, 0, 0, 0   ' Button is clicked
ButtDClk    long  0, 0, 0,  0, 0, 0, 0,  0, 0, 0, 0   ' Button is double clicked
}
CON

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
  ClickTime = _xinfreq * pll16x /30
  TimeDebou  = 4

CON  ' block containing constants

  #0, passive, Pressed, ReleasedClick, Pressed_1  ' states of the click detector


VAR  ' block containing variables
  byte  ID_cog     ' cog ID) Id des lokalen Cogs
  long  Sk[60]     ' cog's stack) Stack des Cogs

PUB Start( GlobPtr, AddrOffs ) | i    ' public method Start with GlobPtr, AddrOffs parameters, and "i" local variable)

  Stop  ' stop cog using private method Stop) Start can restart, therefore stop a possibly running cog first
  ' Create a local copy of the global pointer array and do the address correction "quick and dirty"
  repeat i from 0 to LONG[LONG[GlobPtr +   0]+AddrOffs]-1       
    LONG[@LoclPtr + (i<<2)] := LONG[GlobPtr + (i<<2)] + AddrOffs
      
  ifnot ID_cog  ' if cog ID isn't valid i.e. ID_cog=0)
    ID_cog := cognew(CogProc, @Sk) + 1       '  create cog/process that runs CogProc method using Sk stack )
  ' now wait for started process to return version #
  Repeat while ( i := LONG[LONG[GlobPtr +  0] + AddrOffs]) > 0
  Result := i<<4 + ID_Cog  '  Return 16* Version + ID-Cog

PRI Stop           '  
  if ID_cog  '  if ID_cog is valid i.e. ID_Cog<>0; if cog exists ID_cog is in {1,2,3,...,8} )
    cogstop(ID_cog~ - 1)       '  stop cog/process with "ID_cog-1" ID; cogs have IDs in range (0,1,2,...,7);

PRI CogProc | i
{ Commands:
  1: Idle
  2: Run the button and encoder scanner
}  

'LoclPtr is the pointer to the block of pointers to the global memory

  count     := 0
  PinA      := long [ButtStatPtr] >>5
  PinB      := long [ButtStatPtr] &  %11111
  EncState  := ina[PinB]<<1 + ina[PinA]   ' read encoder pins
  MaxButton := long [ButtCounPtr]
  LongFill ( @TimeChanged, cnt, MaxButton)
  LongFill ( @BouncButton, TimeDebou, MaxButton)
  repeat Button from 0 to MaxButton-1
     ButtPins[Button] := Long[ButtPinsPtr][Button]


  ButtPola   := (Long[ButtStatPtr][1]<<1)-1 ' Low active button, 1: high active button
  ButtMode   :=  Long[ButtStatPtr][2]       ' 0: Low active button, 1: high active button
  


  Long[CommandPtr] := ButtVers  ' Acknowledge commant to show process is running
  
  repeat

  

 {'   repeat while (LocCmd := Long[CommandPtr]) == 0 ' Wait for new command (create local copy)

    case LocCmd  ' switch-case statement; execute appropriate action based on local command)

      Idle: ' case Idle) Idle (has to be recognized in Idle state too)
        Long[CommandPtr] := 0 '  *(long*)(CommandPtr)=0; confirm that is command in idle state =0 i.e. cog is running)

  
   }
  
    NxtState :=  ina[PinB]<<1 + ina[PinA]
    case EncState
   
      %00:  case  NxtState
              %01 : count ++
              %10 : count --

      %01:  case  NxtState
              %11 : count ++
              %00 : count --

      %11:  case  NxtState
              %10 : count ++
              %01 : count --

      %10:  case  NxtState
              %00 : count ++
              %11 : count --
    LONG[ButtCounPtr] := count   ' copy counter to the global memory
    EncState := NxtState
     
    ' do the buttons:
    repeat Button from 0 to MaxButton-1

      ButtonPin := LookUpZ (Button: ButtPins[0], ButtPins[1],ButtPins[2], ButtPins[3], ButtPins[4], ButtPins[5], ButtPins[6], ButtPins[7], ButtPins[8], ButtPins[9], ButtPins[10])
      case ButtMode
        0:  ' Read I/O-Pin directly
          BouncButton[Button] += (ina[ButtonPin]<<1 -1) * ButtPola
        1:  ' read pins from register
          BouncButton[Button] += (( (long[ButtRegiPtr] >> ButtonPin) &1 )<<1 -1) * ButtPola   
        
      BouncButton[Button] := TimeDebou <# (0  #> BouncButton[Button])  ' limit button counter
      if (BouncButton[Button] == 0) or (BouncButton[Button] == TimeDebou)
        DBounButton[Button] := BouncButton[Button]    ' get debounced button only

      if LDBouButton[Button] <> DBounButton[Button]  ' Button changed
        TimeChanged[Button] := cnt                    ' save the change time
        LDBouButton[Button] := DBounButton[Button]    ' transition detected
        long[ButtStatPtr][Button] := (DBounButton[Button]<>0)&1 ' sends 0/1 for pressed
        ButtChgd       := True
      else   ' Button didn't change, so its time to measure the states time  
        if long[ButtStatPtr][Button] >0
          long[ButtStatPtr][Button] := long[ButtStatPtr][Button]+1 <# 500
        else
 '         long[ButtStatPtr][Button] --
          long[ButtStatPtr][Button] := long[ButtStatPtr][Button]-1 #> -500
          
      Case StateButton[Button]

        passive:
           if  DBounButton[Button] == TimeDebou and ButtChgd   'Wait for button pressed
             StateButton[Button] := Pressed
           ButtChgd  := False
              
        Pressed:  
           if ButtChgd
             StateButton[Button] := ReleasedClick
             ButtChgd  := False
           elseif  cnt - TimeChanged[Button]  >  ClickTime     ' Pressed time out
             StateButton[Button] := Passive

        ReleasedClick:
           if ButtChgd
             StateButton[Button] := Pressed_1
             ButtChgd  := False
           elseif cnt - TimeChanged[Button]  >  ClickTime     ' time out, no second click
             StateButton[Button] := Passive
             long[ButtClckPtr][Button] := True

        Pressed_1:  
           if ButtChgd
             long[ButtDClkPtr][Button] := True
             StateButton[Button] := Passive
             ButtChgd  := False
           elseif cnt - TimeChanged[Button]  > ClickTime     ' time out, not released
             StateButton[Button] := Passive

DAT  '  block containing data )
  LoclPtr
  CommandPtr  long  02   ' pointer to command of this process)
  ButtCounPtr long  0    ' counter of quadrature encoder
  ButtPinsPtr long  0    ' Pins of the inputs used
  ButtStatPtr long  0    ' debounced status of input pin 1:1
  ButtClckPtr long  0    ' Click detected, set by buttons
  ButtDClkPtr long  0    ' double click detected
  ButtRegiPtr long  0    ' Register it input redirected

'--------------------------------------------------
  MaxButton   long  0    ' Number of buttons to scan

  ButtPins    long  0, 0, 0,  0, 0, 0, 0,  0, 0, 0, 0
  BouncButton long  0, 0, 0,  0, 0, 0, 0,  0, 0, 0, 0  
  DBounButton long  0, 0, 0,  0, 0, 0, 0,  0, 0, 0, 0   
  LDBouButton long  0, 0, 0,  0, 0, 0, 0,  0, 0, 0, 0  
  TimeChanged long  0, 0, 0,  0, 0, 0, 0,  0, 0, 0, 0
  StateButton long  0, 0, 0,  0, 0, 0, 0,  0, 0, 0, 0

  LocCmd      long 0

  EncState    long  0
  NxtState    long  0
  Button      long  0
  ButtonPin   long  0
  ButtChgd    long  0
  Count       long  0
  PinA        long  0
  PinB        long  0
  ButtPola    long  0
  ButtMode    long  0