{{ToucButt:
2014/11/17 testing quick-start pcb-switches: out pulse and detect decay.

}}

CON 'Commands for Touch Buttons Detector
  #1, Idle, Run   ' Load Parameters, .... to be updated, now just simple
  ToBuVers = -3  ' Process version at return has to be negative as the number of parameters passed at call is positive!
{
  NmbToBuPar = 03 ' Touch Button Detector process: number of parameters
DAT  PrCBToBu long @ToBuCmd, @PinsRegi, @DecayTim                                                 

ToBuCmd     long  0 ' to control the Touch Button Detector process
PinsRegi    long  0 ' This register reflects the pins decayed state, at start: Pins to detect
DecayTim    long  0 ' Time to allow signal decay
}
VAR  ' block containing variables
  byte  ID_cog     ' cog ID
  long  Sk[60]     ' cog's stack

PUB Start( GlobPtr, AddrOffs ) | i
  Stop  ' Start can restart, therefore stop a possibly running cog first
  ' Create a local copy of the global pointer array and do the address correction
  repeat i from 0 to LONG[LONG[GlobPtr +   0]+AddrOffs]-1       
    LONG[@LoclPtr + (i<<2)] := LONG[GlobPtr + (i<<2)] + AddrOffs
      
  ifnot ID_cog  ' if cog ID isn't valid i.e. ID_cog=0)
    ID_cog := cognew(@CogProc, @Sk) + 1       '  create cog/process that runs CogProc method using Sk stack )
  ' now wait for started process to return version #
  Repeat while ( i := LONG[LONG[GlobPtr +  0] + AddrOffs]) > 0
  Result := i<<4 + ID_Cog  '  Return 16* Version + ID-Cog

PRI Stop           '  
  if ID_cog  '  if ID_cog is valid i.e. ID_Cog<>0; if cog exists ID_cog is in {1,2,3,...,8} )
    cogstop(ID_cog~ - 1)       '  stop cog/process with "ID_cog-1" ID; cogs have IDs in range (0,1,2,...,7);

DAT

                        org
CogProc                                                                                                                                    
              rdlong    ToBuPins, ToBuRegiPtr
              rdlong    DecayTim, DecayTimPtr
              mov       outa,     ToBuPins              ' set TestPins high, but keep as inputs

              mov       WaitTimr, cnt                   ' preset the counter
              add       WaitTimr, DecayTim
              wrlong    Reading,  CommandPtr            ' acknowledge start: default reading: version#
Loop
              or        dira,     ToBuPins              ' set TestPins as outputs (high)
              andn      dira,     ToBuPins              ' set TestPins as inputs (floating)
              mov       Reading,  ToBuPins              ' create a mask of applicable pins
              waitcnt   WaitTimr, DecayTim              ' wait for the voltage to decay
              andn      Reading,  ina                   ' clear decayed pins from the mask
              wrlong    Reading,  ToBuRegiPtr           ' write the result to RAM
              jmp       #Loop

LoclPtr  ' All pointers to global memory
CommandPtr   long  0        ' command for ArtiHall
ToBuRegiPtr  long  0        ' pulse/pause ratio
DecayTimPtr  long  0        ' Time to allow decay of input signal

' Local memory
Reading       long ToBuVers   ' Register to read input
ToBuPins      res       1   ' Pins stimulate and read back
DecayTim      res       1   ' Time to allow decay
WaitTimr      res       1   ' Timer